diff a/src/hotspot/share/opto/c2_globals.hpp b/src/hotspot/share/opto/c2_globals.hpp
--- a/src/hotspot/share/opto/c2_globals.hpp
+++ b/src/hotspot/share/opto/c2_globals.hpp
@@ -491,10 +491,33 @@
           "Exit or throw assert in EA when it reaches time limit")          \
                                                                             \
   notproduct(bool, PrintEscapeAnalysis, false,                              \
           "Print the results of escape analysis")                           \
                                                                             \
+  product(bool, DoPartialEscapeAnalysis, true, EXPERIMENTAL,                \
+          "Perform partial escape analysis")                                \
+                                                                            \
+  product(ccstr, PEAMethodOnly, nullptr, EXPERIMENTAL,                      \
+          "perform PEA for only matched methods")                           \
+                                                                            \
+  product(bool, PEAParanoid, false, EXPERIMENTAL,                           \
+          "Abort when C2 expands an object which has been materialized."    \
+          "Duplicated allocation is detected caused by PEA.")               \
+                                                                            \
+  notproduct(bool, PEAVerbose, false,                                       \
+          "trace PEA in verbose")                                           \
+                                                                            \
+  notproduct(intx, PEA_debug_idx, 0,                                        \
+          "only select ObjID in PEA when debug_idx > 0;"                    \
+          "skip ObjID if debug_idx < 0")                                    \
+                                                                            \
+  notproduct(intx, PEA_debug_start, 0,                                      \
+          "only start performing PEA after _debug_start")                   \
+                                                                            \
+  notproduct(intx, PEA_debug_stop, INT_MAX,                                 \
+          "stop performing PEA after (excluded) _debug_stop")               \
+                                                                            \
   product(bool, EliminateAllocations, true,                                 \
           "Use escape analysis to eliminate allocations")                   \
                                                                             \
   notproduct(bool, PrintEliminateAllocations, false,                        \
           "Print out when allocations are eliminated")                      \
